/* Tecnisa - Tecnologia em Informtica

Nome: Grava custo lquido

Descrio:
 Procedimento para atualizao do custo lquido (VRLANCTOEST).

Criao:
30/09/98 - Roberto A. Lopes Martins

Manutenes:
16/07/99 Roberto   - Utilizao do campo CdFiliMovi para atualizao
__/__/__ _________ - _____________________________________________
__/__/__ _________ - _____________________________________________
__/__/__ _________ - _____________________________________________

@C:\WEB_501\Sql\End_conv\Oracle\4003_ESTSTPO_CUSTO_LIQUIDO.SQL

raise_application_error(-20501, '' , True);

SHOW ERRO PROCEDURE CUSTO_LIQUIDO
*/

CREATE OR REPLACE PROCEDURE CUSTO_LIQUIDO(
   P_FILIAL       IN FILIAL.CDFILIAL%TYPE,                --Filial de Lanamento
   P_LANCTO       IN ITLANCTOEST.NRLANCESTQ%TYPE,
   P_TOTALPROD    IN NUMBER,
   P_DIFERENCA    IN NUMBER DEFAULT NULL,
   P_GRAVVRBRUT   IN VARCHAR2 DEFAULT 'N')
AS
   V_CDTIPOOPER VARCHAR2(02);

   V_FATOCONV      NUMBER;
   V_LANCTOEST     NUMBER;
   V_DIFERENCA     NUMBER;
   V_QUANTIDADE    NUMBER;
   V_VRINDICE1     NUMBER;
   V_VRINDICE2     NUMBER;
   V_COUNT         NUMBER;
   V_VRULTCMPLIQ   NUMBER;
   V_VRULTCMPBRU   NUMBER;
   V_VRULTCMPLM1   NUMBER;
   V_VRULTCMPLM2   NUMBER;
   V_VRULTCMPBM1   NUMBER;
   V_VRULTCMPBM2   NUMBER;

   V_NRULTLANCA   VARCHAR2(20);
   V_CDINDICEMF   VARCHAR2(04);
   V_CDINDICEMF2  VARCHAR2(04);
   V_CDTPINDICE   VARCHAR2(01);
   V_IDPERVALOR   VARCHAR2(01);
   V_CDTPINDICE2  VARCHAR2(01);
   V_IDPERVALOR2  VARCHAR2(01);

   V_CDFILLANCEST VARCHAR2(04);
   V_NRLANCESTQ   VARCHAR2(10);

   V_VRCUSTLCMPM1  NUMBER;
   V_VRCUSTLCMPM2  NUMBER;
   V_VRSEGULCMPM1  NUMBER;
   V_VRSEGULCMPM2  NUMBER;
BEGIN
   IF (P_DIFERENCA IS NULL) THEN
      V_DIFERENCA := 0;
   END IF;

   BEGIN
      SELECT MAX(NVL(CDTPINDICE,'1')),  MAX(NVL(IDPERVALOR,'2')),  MAX(CDINDICEMF),
             MAX(NVL(CDTPINDICE2,'1')), MAX(NVL(IDPERVALOR2,'2')), MAX(CDINDICEMF2)
      INTO V_CDTPINDICE,  V_IDPERVALOR,  V_CDINDICEMF,
           V_CDTPINDICE2, V_IDPERVALOR2, V_CDINDICEMF2
      FROM PARAMGERAL;
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_CDTPINDICE  := Null;  V_IDPERVALOR  := Null;  V_CDINDICEMF   := Null;
         V_CDTPINDICE2 := Null;  V_IDPERVALOR2 := Null;   V_CDINDICEMF2 := NULL;
   END;

   FOR C_FATOCONV IN (SELECT A.DTLANCMOVI,  A.NRSEQUITEM,   A.CDPRODUTO,    A.CDPRODMOVI,
                             NVL(A.VRLANCTOEST,0) AS VRLANCTOEST, NVL(A.VRLANCTOBRUT,0) AS VRLANCTOBRUT,
                             B.VRFATOCONV,  D.NRLANCTONF, QTTOTLANCTO,   A.VRTOTLANCTO,  A.VRUNILANCTO,
                             A.CDFILIMOVI,  D.IDTPLANCTO,  A.CDALMOXARIFE, A.CDLOCALESTOQ, A.NRLOTEESTQ,
                             A.NRSUBLOTE,   D.NRLANCESTQ,   D.CDFILIAL, DECODE(QTTOTLANCTO, 0, 0, (VRCUSTLOGLAN/QTTOTLANCTO)) AS VRCUSTLOGLAN,
                             DECODE(QTTOTLANCTO, 0, 0, (VRSEGULOGLAN /QTTOTLANCTO)) AS VRSEGULOGLAN
                       FROM ITLANCTOEST A, PRODUTO B, PRODFILI C, LANCTOESTOQ D
                       WHERE (A.CDFILIAL   = P_FILIAL)       AND
                             (A.NRLANCESTQ = P_LANCTO)       AND
                             (B.CDPRODUTO  = A.CDPRODUTO)    AND
                             (C.CDFILIAL   = A.CDFILIMOVI)   AND
                             (C.CDPRODUTO  = A.CDPRODMOVI)   AND
                             (D.CDFILIAL   = A.CDFILIAL)     AND
                             (D.NRLANCESTQ = A.NRLANCESTQ)) LOOP

      V_VRULTCMPLIQ  := 0;
      V_VRULTCMPBRU  := 0;
      V_VRULTCMPLM1  := 0;
      V_VRULTCMPLM2  := 0;
      V_VRULTCMPBM1  := 0;
      V_VRULTCMPBM2  := 0;

      IF (V_CDINDICEMF IS NOT NULL) THEN
         BEGIN
            SELECT MAX(VRINDICE)
            INTO V_VRINDICE1
            FROM  INDICE I, MOVINDICE M
            WHERE I.CDTPINDICE = V_CDTPINDICE            AND
                  I.IDPERVALOR = V_IDPERVALOR            AND
                  I.CDINDICE   = V_CDINDICEMF            AND
                  M.CDTPINDICE = I.CDTPINDICE            AND
                  M.IDPERVALOR = I.IDPERVALOR            AND
                  M.CDINDICE   = I.CDINDICE              AND
                  TO_CHAR(M.DTREFIND,'DD/MM/YYYY')   = TO_CHAR(C_FATOCONV.DTLANCMOVI,'DD/MM/YYYY');
         EXCEPTION
            WHEN NO_DATA_FOUND THEN
               V_VRINDICE1 := 0;
         END;

         IF (V_VRINDICE1 = 0) THEN
            raise_application_error(-20501, ' ndice Financeiro Parametrizado na Personalizao do Sistema,
                                             no Possue valor Cadastrado para a Data '||  TO_CHAR(C_FATOCONV.DTLANCMOVI,'DD/MM/YYYY')  , True);
         END IF;
      END IF;

      IF (V_CDINDICEMF2 IS NOT NULL) THEN
         BEGIN
            SELECT MAX(VRINDICE)
            INTO V_VRINDICE2
            FROM  INDICE I, MOVINDICE M
            WHERE I.CDTPINDICE = V_CDTPINDICE2           AND
                  I.IDPERVALOR = V_IDPERVALOR2           AND
                  I.CDINDICE   = V_CDINDICEMF2           AND
                  M.CDTPINDICE = I.CDTPINDICE            AND
                  M.IDPERVALOR = I.IDPERVALOR            AND
                  M.CDINDICE   = I.CDINDICE              AND
                  TO_CHAR(M.DTREFIND,'DD/MM/YYYY')   =  TO_CHAR(C_FATOCONV.DTLANCMOVI,'DD/MM/YYYY');
         EXCEPTION
            WHEN NO_DATA_FOUND THEN
               V_VRINDICE2 := 0;
         END;

        IF (V_VRINDICE2 = 0) THEN
            raise_application_error(-20501, 'ndice Financeiro Parametrizado na Personalizao do Sistema,
                                             no Possue valor Cadastrado para a Data '||TO_CHAR(C_FATOCONV.DTLANCMOVI,'DD/MM/YYYY'), True);
         END IF;
             
      END IF;

      IF (C_FATOCONV.VRFATOCONV IS NULL) OR (C_FATOCONV.VRFATOCONV = 0) THEN
         V_FATOCONV := 1;
      ELSE
         V_FATOCONV := C_FATOCONV.VRFATOCONV;
      END IF;

      IF C_FATOCONV.QTTOTLANCTO = 0 THEN
         V_QUANTIDADE := 1;
      ELSE
         V_QUANTIDADE := C_FATOCONV.QTTOTLANCTO;
      END IF;

      V_LANCTOEST := 0;

      IF NOT(P_TOTALPROD = 0) THEN  --Nota fiscal de complemento.
         IF NOT(P_DIFERENCA IS NULL) THEN
            V_DIFERENCA  := ((P_DIFERENCA / P_TOTALPROD * C_FATOCONV.VRTOTLANCTO / V_QUANTIDADE) / (V_FATOCONV));
         END IF;

         IF C_FATOCONV.VRLANCTOBRUT = 0 THEN
            V_LANCTOEST := 0;
         ELSE
            V_LANCTOEST := V_DIFERENCA;
         END IF;
      END IF;

      IF NOT (V_LANCTOEST = 0) THEN
-- Parmetro para gravar valor bruto apenas para entrada sem nota fiscal
-- sem imposto.
         IF (P_GRAVVRBRUT = 'S') THEN
            UPDATE ITLANCTOEST
            SET VRLANCTOEST   = VRLANCTOEST  + V_LANCTOEST,
                VRLANCTOBRUT  = VRLANCTOBRUT + V_LANCTOEST
            WHERE (CDFILIAL   = P_FILIAL) AND
                  (NRLANCESTQ = P_LANCTO) AND
                  (NRSEQUITEM = C_FATOCONV.NRSEQUITEM);
         ELSE
            UPDATE ITLANCTOEST
            SET VRLANCTOEST   = VRLANCTOEST + V_LANCTOEST
            WHERE (CDFILIAL   = P_FILIAL) AND
                  (NRLANCESTQ = P_LANCTO) AND
                  (NRSEQUITEM = C_FATOCONV.NRSEQUITEM);
         END IF;
      ELSE
         UPDATE ITLANCTOEST
         SET VRLANCTOEST   = VRLANCTOEST + V_LANCTOEST
         WHERE (CDFILIAL   = P_FILIAL) AND
               (NRLANCESTQ = P_LANCTO) AND
               (NRSEQUITEM = C_FATOCONV.NRSEQUITEM);
      END IF;

      IF (P_GRAVVRBRUT = 'S') THEN
         UPDATE ITEMPRODUTO
         SET VRCONTITEM     = VRCONTITEM + (V_LANCTOEST * QTITEMPROD),
             VRBRUTITEM     = VRBRUTITEM + (V_LANCTOEST * QTITEMPROD)
         WHERE (CDFILIAL    = P_FILIAL)              AND
               (NRLANCTONF  = C_FATOCONV.NRLANCTONF) AND
               (NRSEQITPROD = C_FATOCONV.NRSEQUITEM);
      ELSE
         UPDATE ITEMPRODUTO
         SET VRCONTITEM     = VRCONTITEM + (V_LANCTOEST * QTITEMPROD)
         WHERE (CDFILIAL    = P_FILIAL)              AND
               (NRLANCTONF  = C_FATOCONV.NRLANCTONF) AND
               (NRSEQITPROD = C_FATOCONV.NRSEQUITEM);
      END IF;

      IF (C_FATOCONV.QTTOTLANCTO <> 0) AND (NOT (C_FATOCONV.QTTOTLANCTO IS NULL)) AND (C_FATOCONV.IDTPLANCTO IN ('0','2','E'))THEN
          V_COUNT := 0;

         IF (C_FATOCONV.IDTPLANCTO <> 'S') THEN

            BEGIN
               SELECT MAX(CDTIPOOPER)
               INTO V_CDTIPOOPER
               FROM NOTAFISCAL
               WHERE (CDFILIAL    = P_FILIAL)              AND
                     (NRLANCTONF  = C_FATOCONV.NRLANCTONF);
            EXCEPTION
               WHEN NO_DATA_FOUND THEN
                  V_CDTIPOOPER := NULL;
            END;

            IF (NVL(V_CDTIPOOPER,'00') <> '06') THEN

               SELECT MAX(COUNT(*)), MAX(CDFILLANCEST), MAX(NRLANCESTQ) INTO V_COUNT, V_CDFILLANCEST, V_NRLANCESTQ
               FROM CUSTOCMPPROD
               WHERE CDFILIAL       = C_FATOCONV.CDFILIMOVI       AND
                     CDALMOXARIFE   = C_FATOCONV.CDALMOXARIFE     AND
                     CDLOCALESTOQ   = C_FATOCONV.CDLOCALESTOQ     AND
                     NRLOTEESTQ     = C_FATOCONV.NRLOTEESTQ       AND
                     NRSUBLOTE      = C_FATOCONV.NRSUBLOTE        AND
                     CDPRODUTO      = C_FATOCONV.CDPRODMOVI       AND
                     DTCUSTCMPPRO   = C_FATOCONV.DTLANCMOVI
               GROUP BY CDFILLANCEST, NRLANCESTQ;

               IF (C_FATOCONV.IDTPLANCTO <> '0') THEN
                  V_VRULTCMPLIQ := C_FATOCONV.VRLANCTOEST  + V_LANCTOEST;
                  V_VRULTCMPBRU := C_FATOCONV.VRLANCTOBRUT + V_LANCTOEST;
               ELSE
                  V_VRULTCMPLIQ    := ((C_FATOCONV.VRLANCTOEST/C_FATOCONV.QTTOTLANCTO)/V_FATOCONV)  + V_LANCTOEST;
                  V_VRULTCMPBRU    := ((C_FATOCONV.VRLANCTOBRUT/C_FATOCONV.QTTOTLANCTO)/V_FATOCONV) + V_LANCTOEST;
               END IF;

               IF (V_CDINDICEMF IS NOT NULL) THEN
                  IF (C_FATOCONV.IDTPLANCTO <> '0') THEN
                     V_VRULTCMPLM1  := (C_FATOCONV.VRLANCTOEST + V_LANCTOEST)  * V_VRINDICE1;
                     V_VRULTCMPBM1  := (C_FATOCONV.VRLANCTOBRUT + V_LANCTOEST) * V_VRINDICE1;
                     V_VRCUSTLCMPM1 := C_FATOCONV.VRCUSTLOGLAN * V_VRINDICE1;
                     V_VRSEGULCMPM1 := C_FATOCONV.VRSEGULOGLAN * V_VRINDICE1;
                  ELSE
                     V_VRULTCMPLM1  := (((C_FATOCONV.VRLANCTOEST/C_FATOCONV.QTTOTLANCTO)/V_FATOCONV) + V_LANCTOEST)  * V_VRINDICE1;
                     V_VRULTCMPBM1  := (((C_FATOCONV.VRLANCTOBRUT/C_FATOCONV.QTTOTLANCTO)/V_FATOCONV) + V_LANCTOEST) * V_VRINDICE1;
                     V_VRCUSTLCMPM1 := C_FATOCONV.VRCUSTLOGLAN * V_VRINDICE1;
                     V_VRSEGULCMPM1 := C_FATOCONV.VRSEGULOGLAN * V_VRINDICE1;
                  END IF;
               END IF;
               IF (V_CDINDICEMF2 IS NOT NULL) THEN
                  IF (C_FATOCONV.IDTPLANCTO <> '0') THEN
                     V_VRULTCMPLM2  := (C_FATOCONV.VRLANCTOEST + V_LANCTOEST)  * V_VRINDICE2;
                     V_VRULTCMPBM2  := (C_FATOCONV.VRLANCTOBRUT + V_LANCTOEST) * V_VRINDICE2;
                     V_VRCUSTLCMPM2 := C_FATOCONV.VRCUSTLOGLAN * V_VRINDICE2;
                     V_VRSEGULCMPM2 := C_FATOCONV.VRSEGULOGLAN * V_VRINDICE2;
                  ELSE
                     V_VRULTCMPLM2  := (((C_FATOCONV.VRLANCTOEST/C_FATOCONV.QTTOTLANCTO)/V_FATOCONV) + V_LANCTOEST)  * V_VRINDICE2;
                     V_VRULTCMPBM2  := (((C_FATOCONV.VRLANCTOEST/C_FATOCONV.QTTOTLANCTO)/V_FATOCONV) + V_LANCTOEST)  * V_VRINDICE2;
                     V_VRCUSTLCMPM2 := C_FATOCONV.VRCUSTLOGLAN * V_VRINDICE2;
                     V_VRSEGULCMPM2 := C_FATOCONV.VRSEGULOGLAN * V_VRINDICE2;
                  END IF;
               END IF;

               IF ( NVL(V_COUNT,0) = 0) THEN

                  INSERT INTO CUSTOCMPPROD
                     (CDFILIAL,     DTCUSTCMPPRO,   CDFILLANCEST,   NRLANCESTQ,   CDPRODUTO,
                      CDALMOXARIFE, CDLOCALESTOQ,   NRLOTEESTQ,     NRSUBLOTE,    VRLIQCMPPROD,
                      VRBRUCMPPROD, VRLIQCMPPRM1,   VRLIQCMPPRM2,   VRBRUCMPPRM1, VRBRUCMPPRM2,
                      VRCUSTLOGCMP, VRCUSTLCMPM1,   VRCUSTLCMPM2,   VRSEGULOGCMP, VRSEGULCMPM1,
                      VRSEGULCMPM2)
                  VALUES
                     (C_FATOCONV.CDFILIMOVI, C_FATOCONV.DTLANCMOVI,   C_FATOCONV.CDFILIAL,    C_FATOCONV.NRLANCESTQ,
                      C_FATOCONV.CDPRODMOVI, C_FATOCONV.CDALMOXARIFE, C_FATOCONV.CDLOCALESTOQ, C_FATOCONV.NRLOTEESTQ,
                      C_FATOCONV.NRSUBLOTE,  V_VRULTCMPLIQ, V_VRULTCMPBRU, V_VRULTCMPLM1,  V_VRULTCMPLM2, V_VRULTCMPBM1,
                      V_VRULTCMPBM2,  C_FATOCONV.VRCUSTLOGLAN, V_VRCUSTLCMPM1,   V_VRCUSTLCMPM2,   C_FATOCONV.VRSEGULOGLAN,
                      V_VRSEGULCMPM1, V_VRSEGULCMPM2);
               ELSE

                  IF (C_FATOCONV.IDTPLANCTO = '0') THEN
                     IF ((V_CDFILLANCEST = C_FATOCONV.CDFILIAL) AND (V_NRLANCESTQ = C_FATOCONV.NRLANCESTQ)) THEN
                        UPDATE CUSTOCMPPROD
                        SET VRLIQCMPPROD   = V_VRULTCMPLIQ,
                            VRBRUCMPPROD   = V_VRULTCMPBRU,
                            VRLIQCMPPRM1   = V_VRULTCMPLM1,
                            VRLIQCMPPRM2   = V_VRULTCMPLM2,
                            VRBRUCMPPRM1   = V_VRULTCMPBM1,
                            VRBRUCMPPRM2   = V_VRULTCMPBM2,
                            NRLANCESTQ     = C_FATOCONV.NRLANCESTQ,
                            CDFILLANCEST   = C_FATOCONV.CDFILIAL,
                            VRCUSTLOGCMP   = C_FATOCONV.VRCUSTLOGLAN,
                            VRCUSTLCMPM1   = V_VRCUSTLCMPM1,
                            VRCUSTLCMPM2   = V_VRCUSTLCMPM2,
                            VRSEGULOGCMP   = C_FATOCONV.VRSEGULOGLAN,
                            VRSEGULCMPM1   = V_VRSEGULCMPM1,
                            VRSEGULCMPM2   = V_VRSEGULCMPM2
                        WHERE CDFILIAL       = C_FATOCONV.CDFILIMOVI       AND
                              CDALMOXARIFE   = C_FATOCONV.CDALMOXARIFE     AND
                              CDLOCALESTOQ   = C_FATOCONV.CDLOCALESTOQ     AND
                              NRLOTEESTQ     = C_FATOCONV.NRLOTEESTQ       AND
                              NRSUBLOTE      = C_FATOCONV.NRSUBLOTE        AND
                              CDPRODUTO      = C_FATOCONV.CDPRODMOVI       AND
                              DTCUSTCMPPRO   = C_FATOCONV.DTLANCMOVI;
                     END IF;
                  ELSE
                     SELECT MAX(NRLANCESTQ||CDFILIAL)
                     INTO V_NRULTLANCA
                     FROM ITLANCTOEST I
                     WHERE CDFILIMOVI   = C_FATOCONV.CDFILIMOVI       AND
                           CDALMOXARIFE = C_FATOCONV.CDALMOXARIFE     AND
                           CDLOCALESTOQ = C_FATOCONV.CDLOCALESTOQ     AND
                           NRLOTEESTQ   = C_FATOCONV.NRLOTEESTQ       AND
                           NRSUBLOTE    = C_FATOCONV.NRSUBLOTE        AND
                           CDPRODUTO    = C_FATOCONV.CDPRODUTO        AND
                           DTLANCMOVI   = C_FATOCONV.DTLANCMOVI;

                     IF (V_NRULTLANCA = C_FATOCONV.NRLANCESTQ||C_FATOCONV.CDFILIAL) THEN
                        UPDATE CUSTOCMPPROD
                        SET VRLIQCMPPROD  = V_VRULTCMPLIQ,
                            VRBRUCMPPROD  = V_VRULTCMPBRU,
                            VRLIQCMPPRM1  = V_VRULTCMPLM1,
                            VRLIQCMPPRM2  = V_VRULTCMPLM2,
                            VRBRUCMPPRM1  = V_VRULTCMPBM1,
                            VRBRUCMPPRM2  = V_VRULTCMPBM2,
                            NRLANCESTQ    = SUBSTR(V_NRULTLANCA,1,10),
                            CDFILLANCEST  = SUBSTR(V_NRULTLANCA,11,4),
                            VRCUSTLOGCMP   = C_FATOCONV.VRCUSTLOGLAN,
                            VRCUSTLCMPM1   = V_VRCUSTLCMPM1,
                            VRCUSTLCMPM2   = V_VRCUSTLCMPM2,
                            VRSEGULOGCMP   = C_FATOCONV.VRSEGULOGLAN,
                            VRSEGULCMPM1   = V_VRSEGULCMPM1,
                            VRSEGULCMPM2   = V_VRSEGULCMPM2
                        WHERE CDFILIAL       = C_FATOCONV.CDFILIMOVI       AND
                              CDALMOXARIFE   = C_FATOCONV.CDALMOXARIFE     AND
                              CDLOCALESTOQ   = C_FATOCONV.CDLOCALESTOQ     AND
                              NRLOTEESTQ     = C_FATOCONV.NRLOTEESTQ       AND
                              NRSUBLOTE      = C_FATOCONV.NRSUBLOTE        AND
                              CDPRODUTO      = C_FATOCONV.CDPRODMOVI       AND
                              DTCUSTCMPPRO   = C_FATOCONV.DTLANCMOVI;
                     END IF;
                  END IF;
               END IF;
            END IF;
         END IF;
      END IF;
   END LOOP;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('CUSTO_LIQUIDO','5.01.010'); END;
/

