/*
 @C:\WEB_511\Sql\End_Conv\Oracle\5055_FISSTPO_Consulta_Fiscal.SQL

 Descrio:
 Procedure para consulta dos Parametros fiscais

*/
IF EXISTS (SELECT * FROM SYSOBJECTS O, SYSUSERS U
                    WHERE
	        O.NAME = 'CONSULTA_FISCAL_PROD' AND
	        TYPE = 'P' 			         AND
	        U.UID = O.UID             	AND
	        U.NAME = USER)
DROP PROCEDURE CONSULTA_FISCAL_PROD;
GO
CREATE PROCEDURE CONSULTA_FISCAL_PROD(
    @P_EMPRESA        VARCHAR(2),
    @P_ENTRSAID       VARCHAR(1),
    @P_TIPOOPER       VARCHAR(2),
    @P_INSCESTA       VARCHAR(16),
    @P_CDARVPROD      VARCHAR(20),
    @P_INIVALID       DATETIME,
    @P_DTENTRFIS      DATETIME,
    @P_IMPOSTO        VARCHAR(2),
    @P_PAISORIG       VARCHAR(4),
    @P_ESTAORIG       VARCHAR(2),
    @P_PAISDEST       VARCHAR(4),
    @P_ESTADEST       VARCHAR(2),
    @P_CDMUNICIPIO    VARCHAR(4),
    @P_FILIAL         VARCHAR,
    @P_LANCTONF       VARCHAR(10),
    @P_CDORIGDESTNF   VARCHAR ,
    @P_CDFILIORIG     VARCHAR ,
    @P_CDFILIDEST     VARCHAR 
)
AS
  DECLARE @V_IDORIGDESTNF VARCHAR(01);
  DECLARE @V_CDGRUPOFISC  VARCHAR(03);
  DECLARE @V_IDINTEREST   VARCHAR(01);
  DECLARE @V_IDINTERNA    VARCHAR(01);
  DECLARE @V_CDFORNECED   VARCHAR(21);
  DECLARE @V_CDCLIENTE    VARCHAR(21);
  DECLARE @V_INCITEMP     VARCHAR(14);
  DECLARE @V_CDIMPOTEMP   VARCHAR(02);
  DECLARE @V_CDFISCTEMP   VARCHAR(01);
  DECLARE @V_EXISTE       INTEGER;
  DECLARE @V_CDGRUPOFISCAUX VARCHAR(03);
  DECLARE @V_SITUTRIBPR   VARCHAR(03);
  DECLARE @V_CDSITTRIBTMP    VARCHAR(2);
  DECLARE @V_IDMODBCNFE      VARCHAR(1);
  DECLARE @V_IDMOTIDESSTNFE  VARCHAR(10);
  DECLARE @V_IDMODBCSTNFE    VARCHAR(1);
  DECLARE @V_CDTPCRPICOSTNFE VARCHAR(10);
  DECLARE @V_CDNATUBCPCSTNFE VARCHAR(10);
  DECLARE @V_FISOPEITEM     VARCHAR(11);
  DECLARE @V_SUFXCFOPPR     VARCHAR(03);
  DECLARE @V_PARDEDTMP    INTEGER;
  DECLARE @V_PREDBCTMP    INTEGER;
  DECLARE @V_ALIQUTMP     INTEGER;
  DECLARE @V_TRATIMPST      VARCHAR(01);
  DECLARE @V_PBCSUBTRIB   INTEGER;
  DECLARE @V_IDPMCBASECAL   VARCHAR(01);
  DECLARE @V_CDREGRAITALIQ    VARCHAR(10);
BEGIN
   DELETE FROM PARAMFISCALPROD
    WHERE CDFILIOPELOG = @P_CDFILIORIG
      AND CDFILDEST = @P_CDFILIDEST
      AND DTERFISCALOL = @P_DTENTRFIS
      AND DTEMBRFISCOL = @P_INIVALID
      AND CDARVPROD = @P_CDARVPROD
      AND CDIMPOSTO = @P_IMPOSTO
      AND IDENTRSAIDOP = @P_ENTRSAID
      AND CDTIPOOPER = @P_TIPOOPER;

   SET @V_INCITEMP = @P_FILIAL + @P_LANCTONF;/* INCIDENCIA */
   SELECT @V_IDORIGDESTNF = IDORIGDESTOP
     FROM TIPOOPERAC
    WHERE IDENTRSAIDOP = @P_ENTRSAID
      AND CDTIPOOPER   = @P_TIPOOPER;

  -- EXEC CONSULTA_GRUPOFISCAL @V_IDORIGDESTNF, @P_CDORIGDESTNF, @P_CDFILIORIG, @P_ENTRSAID, @P_TIPOOPER, @V_CDGRUPOFISC OUTPUT;

   SET @V_IDINTEREST = 'N';
   SET @V_IDINTERNA  = 'N';
   IF ((@P_PAISDEST = @P_PAISORIG) AND (@P_ESTADEST <> @P_ESTAORIG)) BEGIN
   SET @V_IDINTEREST = 'S';
   END
   ELSE BEGIN
      IF (@P_PAISDEST <> @P_PAISORIG) BEGIN
         SET @V_IDINTERNA = 'S';
      END;
   END;

   SET @V_CDCLIENTE  = NULL;
   SET @V_CDFORNECED = NULL;
   
   IF @V_IDORIGDESTNF = 'C' BEGIN
      SET @V_CDCLIENTE = @P_CDORIGDESTNF;
   END
   ELSE BEGIN IF @V_IDORIGDESTNF = 'F' 
      SET @V_CDFORNECED = @P_CDORIGDESTNF;
   END;

   EXEC CONSULTA_INCIDENCIA @P_ENTRSAID, @P_EMPRESA, @P_CDARVPROD, @P_INSCESTA, @P_TIPOOPER, @P_FILIAL, @P_LANCTONF, @V_CDGRUPOFISC, null, @V_IDINTEREST, 'PED', @P_CDFILIDEST, @V_CDFORNECED, @V_CDCLIENTE, P_@INIVALID, @P_CDFILIORIG;

   SELECT V_CDGRUPOFISCAUX = MAX(G.CDGRUPOFISC) 
     FROM GRUPOFISCIMPFIL G
    WHERE G.CDFILIAL = @P_CDFILIORIG
      AND NOT G.CDGRUPOFISC IS NULL
      AND G.CDIMPOSTO = @P_IMPOSTO;

   IF @V_CDGRUPOFISCAUX IS NOT NULL BEGIN
   SET @V_CDGRUPOFISC = @V_CDGRUPOFISCAUX;
   END;

   SELECT @V_CDIMPOTEMP = MAX(CDIMPOTEMP),@V_CDFISCTEMP = MAX(CDFISCTEMP)
     FROM INCITEMP IT
    WHERE (IT.NRINCITEMP = @V_INCITEMP)
      AND (IT.CDIMPOTEMP = @P_IMPOSTO)

   SET @V_EXISTE = 0;
   SELECT @V_EXISTE = COUNT(1)
     FROM PARAMFISCALPROD
    WHERE CDFILIOPELOG = @P_CDFILIORIG
      AND CDFILDEST = @P_CDFILIDEST
      AND DTERFISCALOL = @P_DTENTRFIS
      AND DTEMBRFISCOL = @P_INIVALID
      AND CDARVPROD = @P_CDARVPROD
      AND CDIMPOSTO = @P_IMPOSTO
      AND IDENTRSAIDOP = @P_ENTRSAID
      AND CDTIPOOPER = @P_TIPOOPER;

   IF @V_EXISTE = 0 BEGIN
      IF @V_CDIMPOTEMP IS NULL BEGIN
         INSERT INTO PARAMFISCALPROD
            (CDFILIOPELOG, CDFILDEST, DTERFISCALOL, DTEMBRFISCOL, CDARVPROD, CDIMPOSTO,
             IDENTRSAIDOP, CDTIPOOPER, CDFISCAL, CDGRUPOFISC, CDPAISOL, SGESTADOOL,
             CDPAISDEST, SGESTADODEST)
         VALUES
            (@P_CDFILIORIG, @P_CDFILIDEST, @P_DTENTRFIS, @P_INIVALID, @P_CDARVPROD, @P_IMPOSTO,
             @P_ENTRSAID, @P_TIPOOPER,'', @V_CDGRUPOFISC, @P_PAISORIG, @P_ESTAORIG,
             @P_PAISDEST, @P_ESTADEST);
      END
      ELSE 
         INSERT INTO PARAMFISCALPROD
            (CDFILIOPELOG, CDFILDEST, DTERFISCALOL, DTEMBRFISCOL, CDARVPROD, CDIMPOSTO,
             IDENTRSAIDOP, CDTIPOOPER, CDFISCAL, CDGRUPOFISC, CDPAISOL, SGESTADOOL,
             CDPAISDEST, SGESTADODEST)
         VALUES
            (@P_CDFILIORIG, @P_CDFILIDEST, @P_DTENTRFIS, @P_INIVALID, @P_CDARVPROD, @P_IMPOSTO,
             @P_ENTRSAID, @P_TIPOOPER, @V_CDFISCTEMP, @V_CDGRUPOFISC, @P_PAISORIG, @P_ESTAORIG,
             @P_PAISDEST, @P_ESTADEST);
      END;

      EXEC CONSULTA_CST @P_ENTRSAID, @P_EMPRESA, @P_CDARVPROD, @P_INSCESTA, @P_TIPOOPER, @P_FILIAL, @P_LANCTONF, @V_CDGRUPOFISC, @V_IDINTEREST, @V_IDINTERNA, 'PED';
      SELECT @V_SITUTRIBPR = MAX(CDSITTRIBTMP)
        
        FROM CSTTEMP
       WHERE NRCSTTEMP = @V_INCITEMP;

      IF @V_SITUTRIBPR IS NULL BEGIN
          UPDATE PARAMFISCALPROD
             SET CDSITUTRIB = ''
          WHERE CDFILIOPELOG = @P_CDFILIORIG
            AND CDFILDEST = @P_CDFILIDEST
            AND DTERFISCALOL = @P_DTENTRFIS
            AND DTEMBRFISCOL = @P_INIVALID
            AND CDARVPROD = @P_CDARVPROD
            AND CDIMPOSTO = @P_IMPOSTO
            AND IDENTRSAIDOP = @P_ENTRSAID
            AND CDTIPOOPER = @P_TIPOOPER
            AND CDGRUPOFISC = @V_CDGRUPOFISC;
      END
      ELSE 
         UPDATE PARAMFISCALPROD
             SET CDSITUTRIB = @V_SITUTRIBPR
          WHERE CDFILIOPELOG = @P_CDFILIORIG
            AND CDFILDEST = @P_CDFILIDEST
            AND DTERFISCALOL = @P_DTENTRFIS
            AND DTEMBRFISCOL = @P_INIVALID
            AND CDARVPROD = @P_CDARVPROD
            AND CDIMPOSTO = @P_IMPOSTO
            AND IDENTRSAIDOP = @P_ENTRSAID
            AND CDTIPOOPER = @P_TIPOOPER;

      EXEC CONSULTA_CST_NFE @P_ENTRSAID, @P_EMPRESA, @P_CDARVPROD, @P_INSCESTA, @P_TIPOOPER, @V_CDGRUPOFISC, @P_IMPOSTO, @V_IDINTEREST, @V_IDINTERNA, @P_FILIAL, @P_LANCTONF, '',  @V_CDSITTRIBTMP OUTPUT, @V_IDMODBCNFE OUTPUT, @V_IDMODBCSTNFE OUTPUT, @V_CDTPCRPICOSTNFE OUTPUT, @V_CDNATUBCPCSTNFE OUTPUT, @V_IDMOTIDESSTNFE OUTPUT;

      IF @V_CDSITTRIBTMP IS NULL BEGIN
          UPDATE PARAMFISCALPROD
             SET CDSITUTRIBNFE = ''
          WHERE CDFILIOPELOG = @P_CDFILIORIG
            AND CDFILDEST = @P_CDFILIDEST
            AND DTERFISCALOL = @P_DTENTRFIS
            AND DTEMBRFISCOL = @P_INIVALID
            AND CDARVPROD = @P_CDARVPROD
            AND CDIMPOSTO = @P_IMPOSTO
            AND IDENTRSAIDOP = @P_ENTRSAID
            AND CDTIPOOPER = @P_TIPOOPER
            AND CDGRUPOFISC = @V_CDGRUPOFISC;
      END
      ELSE BEGIN
         UPDATE PARAMFISCALPROD
             SET CDSITUTRIBNFE = @V_CDSITTRIBTMP
          WHERE CDFILIOPELOG = @P_CDFILIORIG
            AND CDFILDEST = @P_CDFILIDEST
            AND DTERFISCALOL = @P_DTENTRFIS
            AND DTEMBRFISCOL = @P_INIVALID
            AND CDARVPROD = @P_CDARVPROD
            AND CDIMPOSTO = @P_IMPOSTO
            AND IDENTRSAIDOP = @P_ENTRSAID
            AND CDTIPOOPER = @P_TIPOOPER;
      END;

      EXEC CONSULTA_CFOP @P_ENTRSAID, @P_EMPRESA, @P_CDARVPROD, @P_INSCESTA, @P_TIPOOPER, @P_PAISORIG, @P_ESTAORIG,
                         @P_PAISDEST, @P_ESTADEST, @P_FILIAL, @P_LANCTONF, @V_CDGRUPOFISC, @P_INIVALID;

      SELECT @V_FISOPEITEM = MAX(CDFISOPETMP),@V_SUFXCFOPPR = MAX(CDSUFCFOPTMP) 
        FROM CFOPTEMP
       WHERE NRCFOPTEMP = @V_INCITEMP;

       IF @V_FISOPEITEM IS NULL BEGIN
          UPDATE PARAMFISCALPROD
             SET CDCFOP = ''
          WHERE CDFILIOPELOG = @P_CDFILIORIG
            AND CDFILDEST = @P_CDFILIDEST
            AND DTERFISCALOL = @P_DTENTRFIS
            AND DTEMBRFISCOL = @P_INIVALID
            AND CDARVPROD = @P_CDARVPROD
            AND CDIMPOSTO = @P_IMPOSTO
            AND IDENTRSAIDOP = @P_ENTRSAID
            AND CDTIPOOPER = @P_TIPOOPER
            AND CDGRUPOFISC = @V_CDGRUPOFISC;
      END
      ELSE BEGIN
         UPDATE PARAMFISCALPROD
             SET CDCFOP = @V_FISOPEITEM
          WHERE CDFILIOPELOG = @P_CDFILIORIG
            AND CDFILDEST = @P_CDFILIDEST
            AND DTERFISCALOL = @P_DTENTRFIS
            AND DTEMBRFISCOL = @P_INIVALID
            AND CDARVPROD = @P_CDARVPROD
            AND CDIMPOSTO = @P_IMPOSTO
            AND IDENTRSAIDOP = @P_ENTRSAID
            AND CDTIPOOPER = @P_TIPOOPER;
      END;

      EXEC CONSULTA_ALIQUOTA @P_IMPOSTO, @P_ENTRSAID, @P_EMPRESA, @P_CDARVPROD, @P_INSCESTA, @P_PAISORIG, @P_ESTAORIG,
                             @P_PAISDEST, @P_ESTADEST, @P_CDMUNICIPIO, 0, @P_INIVALID, @P_FILIAL, @P_LANCTONF, @V_CDGRUPOFISC, @P_TIPOOPER,
                             'PED', 'N', 0, @P_CDFILIDEST, @V_CDFORNECED, @V_CDCLIENTE;

        SELECT    @V_PARDEDTMP = ISNULL(MAX(VRPARDEDTMP),0),@V_PREDBCTMP = ISNULL(MAX(VRPREDBCTMP),0),@V_ALIQUTMP = ISNULL(MAX(VRALIQUTMP),0),
                  @V_TRATIMPST = ISNULL(MAX(IDTRIMPSTTMP), '0'),@V_PBCSUBTRIB = ISNULL(MAX(VRPBCSTTMP),0),@V_IDPMCBASECAL = ISNULL(MAX(IDPMCBSCALTMP), 'S'),@V_CDREGRAITALIQ = MAX(CDREGRATMP)                
        FROM ALIQTEMP
        WHERE (NRALIQTEMP = @V_INCITEMP);

      IF (@V_ALIQUTMP IS NULL)  BEGIN
          UPDATE PARAMFISCALPROD
             SET VRALIQUOTA = ''
          WHERE CDFILIOPELOG = @P_CDFILIORIG
            AND CDFILDEST = @P_CDFILIDEST
            AND DTERFISCALOL = @P_DTENTRFIS
            AND DTEMBRFISCOL = @P_INIVALID
            AND CDARVPROD = @P_CDARVPROD
            AND CDIMPOSTO = @P_IMPOSTO
            AND IDENTRSAIDOP = @P_ENTRSAID
            AND CDTIPOOPER = @P_TIPOOPER
            AND CDGRUPOFISC = @V_CDGRUPOFISC;
      END
      ELSE BEGIN
         UPDATE PARAMFISCALPROD
             SET VRALIQUOTA = @V_ALIQUTMP
          WHERE CDFILIOPELOG = @P_CDFILIORIG
            AND CDFILDEST = @P_CDFILIDEST
            AND DTERFISCALOL = @P_DTENTRFIS
            AND DTEMBRFISCOL = @P_INIVALID
            AND CDARVPROD = @P_CDARVPROD
            AND CDIMPOSTO = @P_IMPOSTO
            AND IDENTRSAIDOP = @P_ENTRSAID
            AND CDTIPOOPER = @P_TIPOOPER;
      END;
      IF (@V_PREDBCTMP IS NULL) BEGIN
          UPDATE PARAMFISCALPROD
             SET VRREDUCAOBC = ''
          WHERE CDFILIOPELOG = @P_CDFILIORIG
            AND CDFILDEST = @P_CDFILIDEST
            AND DTERFISCALOL = @P_DTENTRFIS
            AND DTEMBRFISCOL = @P_INIVALID
            AND CDARVPROD = @P_CDARVPROD
            AND CDIMPOSTO = @P_IMPOSTO
            AND IDENTRSAIDOP = @P_ENTRSAID
            AND CDTIPOOPER = @P_TIPOOPER
            AND CDGRUPOFISC = @V_CDGRUPOFISC;
      END
      ELSE BEGIN
         UPDATE PARAMFISCALPROD
             SET VRREDUCAOBC = @V_PREDBCTMP
          WHERE CDFILIOPELOG = @P_CDFILIORIG
            AND CDFILDEST = @P_CDFILIDEST
            AND DTERFISCALOL = @P_DTENTRFIS
            AND DTEMBRFISCOL = @P_INIVALID
            AND CDARVPROD = @P_CDARVPROD
            AND CDIMPOSTO = @P_IMPOSTO
            AND IDENTRSAIDOP = @P_ENTRSAID
            AND CDTIPOOPER = @P_TIPOOPER;
      END;

   DELETE INCITEMP
    WHERE NRINCITEMP = @V_INCITEMP;

   DELETE CSTTEMP
    WHERE NRCSTTEMP = @V_INCITEMP;

   DELETE CFOPTEMP
    WHERE NRCFOPTEMP = @V_INCITEMP;

   DELETE ALIQTEMP
    WHERE NRALIQTEMP = @V_INCITEMP;
END;
GO
